% Show the patterns of the sandpile up to symmetry

clear;

CL = bandpacking(1000);

for k = 1:size(CL,2)

  C = reshape(CL(:,k),[2 4]);

  C0 = C(:,1);
  C1 = C(:,2);
  C2 = C(:,3);
  C3 = C(:,4);

  [G0,G1,G2,G3,v32,v13,v21,a32,a13,a21] = odometer(C0,C1,C2,C3);

  v10 = v13-i*v21;
  v20 = v21-i*v32;
  v30 = v32-i*v13;

  a10 = a13+i*a21;
  a20 = a21+i*a32;
  a30 = a32+i*a13;

  G = pad(G0);

  for iter = 1:1
    H = translate(G,v10,a10); G = max(G,H+max(G(:)-H(:)));
    H = translate(G,v20,a20); G = max(G,H+max(G(:)-H(:)));
    H = translate(G,v30,a30); G = max(G,H+max(G(:)-H(:)));
  end

  clf;

  L = laplacian(G) + 2;
  L(isnan(L)&isfinite(G)) = 3;
  drawpattern(L);
  text(1,1,sprintf('(%d,%d+%di)',C0(1),real(C0(2)),imag(C0(2))));

  pause;

end
